chiark / gitweb /
setup, pulseaudio, git: Add PulseAudio configuration; substituted dotfiles.
[profile] / setup
1 #! /bin/bash
2
3 set -e
4
5 ###--------------------------------------------------------------------------
6 ### Basic setup.
7
8 umask 002
9
10 sub=
11 mkdir -p $HOME$sub
12
13 : ${REPO=http://ftp.distorted.org.uk/ftp/pub/mdw/profile}
14
15 export PATH=/usr/local/bin:$HOME$sub/bin:/usr/bin:/usr/ccs/bin:/bin
16
17 ###--------------------------------------------------------------------------
18 ### Sort out command line.
19
20 xstuff= false=
21 while [ $# -gt 0 ]; do
22   case "$1" in
23     -x) xstuff=t;;
24     -n) false=false;;
25     --) shift; break;;
26     -*) echo >&2 "$0: bad option"; exit 1;;
27     *) break;;
28   esac
29   shift
30 done
31
32 ###--------------------------------------------------------------------------
33 ### Environment autoconfiguration.
34
35 ## Find out where I am
36 here=$(pwd)
37
38 ## Suss out how to print things
39 out=$(echo -n "foo"; echo "bar")
40 if [ "$out" = "foobar" ]; then
41   echon="echo -n"
42   echoc=""
43 else
44   echon="echo"
45   echoc='\c'
46 fi
47
48 ## Find out how to fetch things over the net
49 $echon "Finding URL fetcher:$echoc"
50 if curl >/dev/null 2>&1 --version || [ $? -eq 2 ]; then
51   GETURL="curl -fs -o"
52   echo " curl."
53 elif wget >/dev/null 2>&1 --version; then
54   GETURL="wget -q -O"
55   echo " wget."
56 else
57   echo " failed!"
58   echo >&2 "$0: failed to find URL fetcher"
59   exit 1
60 fi
61
62 ###--------------------------------------------------------------------------
63 ### Create the necessary directories.
64
65 echo "Creating directories..."
66 for i in bin lib/emacs src; do
67   $echon "  $i:$echoc"
68   if [ -d $HOME$sub/$i ]; then
69     echo " already exists."
70   else
71     mkdir -p $HOME$sub/$i
72     echo " done."
73   fi
74 done
75 echo "  all done."
76
77 ###--------------------------------------------------------------------------
78 ### Install some more complicated programs.
79
80 echo "Installing packages..."
81 systems="
82   mlib:crc-mktab
83   checkpath:tmpdir
84 "
85 [ "$xstuff" ] && systems="$systems
86   xtoys:xatom
87 "
88 for system in $systems; do
89   set -- $(echo $system | tr : ' ')
90   sys=$1 prog=$2
91   $echon "  $sys:$echoc"
92   if $false $prog >/dev/null 2>&1 --version; then
93     echo " already installed."
94   else
95     ( set -e
96       $echon " downloading$echoc"
97       cd $HOME$sub/src
98       rm -rf $sys.tar.gz $sys-$ver
99       $GETURL $sys.tar.gz $REPO/$sys.tar.gz
100       $echon " unpacking$echoc"
101       dir=$(gzip -cd $sys.tar.gz | tar tf - | head -1)
102       gzip -cd $sys.tar.gz | tar xf -
103       $echon " configuring$echoc"
104       cd $dir
105       mkdir build
106       cd build
107       ../configure --prefix=$HOME$sub >>buildlog 2>&1
108       $echon " building$echoc"
109       make >>buildlog 2>&1
110       $echon " installing$echoc"
111       make install >>buildlog 2>&1
112       echo " done."
113     )
114   fi
115 done
116 echo "  all done."
117
118 ###--------------------------------------------------------------------------
119 ### Install global configuration.
120
121 echo -n "Installing dotfile configuration:"
122 if [ -f $HOME$sub/.mdw.conf ]; then
123   echo " already installed."
124 else
125   cp mdw.conf $HOME$sub/.mdw.conf
126   echo " done."
127 fi
128
129 ## Symlink the various dotfiles into place
130 dotfiles="
131   bash_profile bash_logout bashrc inputrc bash_completion
132   emacs emacs-calc vm gnus.el
133   vimrc mg zile
134   mailrc signature
135   cgrc tigrc
136   gdbinit
137   guile
138   toprc
139   aspell.conf
140   lisp-init.lisp:.cmucl-init.lisp
141     lisp-init.lisp:.sbclrc
142     lisp-init.lisp:.clisprc.lisp
143     lisp-init.lisp:.eclrc
144   swank.lisp
145   dircolors colordiffrc screenrc cvsrc indent.pro"
146 [ "$xstuff" ] && dotfiles="$dotfiles
147   xinitrc xsession Xdefaults vncrc vncsession
148   fonts.conf
149   stalonetrayrc
150   putty-defaults:.putty/sessions/Default%20Settings
151   eterm-theme.cfg:.Eterm/themes/Eterm/theme.cfg
152   e-keybindings.cfg:.enlightenment/keybindings.cfg
153   evnc-keybindings.cfg:.enlightenment-vnc/keybindings.cfg
154   e16-bindings:.e16/bindings.cfg"
155 echo "Installing dotfiles..."
156 for d in $dotfiles; do
157   target=.$d
158   case $d in
159     *:*) target=${d#*:} d=${d%%:*};;
160   esac
161   ft=$HOME$sub/$target
162   dir=${ft%/*}
163   mkdir -p $dir
164   ln -s $here/dot/$d $ft.new
165   mv $ft.new $ft
166   echo "  $target"
167 done
168 echo "  all done."
169
170 ## Substitute things which need substituting.
171 dotfilessubst="
172   gitconfig
173   pulse-default.pa.in:.pulse/default.pa"
174 echo "Installing dotfiles with substitutions..."
175 for d in $dotfilessubst; do
176   case $d in
177     *:*) target=${d#*:} d=${d%%:*};;
178     *) target=.$d d=$d.in;;
179   esac
180   ft=$HOME$sub/$target
181   dir=${ft%/*}
182   mkdir -p $dir
183   sed "
184 1i\
185 ### generated by $here/setup; do not edit!\
186
187 /@home@/ s\a\a$HOME\ag
188 /@releasekey@/ s\a\a$(bin/mdw-conf release-key 481334C2)\ag
189 /@gitignore@/ s\a\a$(bin/mdw-conf gitignore $here/git/gitignore)\ag
190 " dot/$d >$ft.new
191   mv $ft.new $ft
192   echo "  $target"
193 done
194 echo "  all done."
195
196 ## Symlink backgrounds.
197 backgrounds="
198   jue-peek.jpg
199   medusa.jpg
200   bsg-supper.jpg
201   rayne.jpg
202   hypatia.jpg
203   noodly.jpg
204   lovelace.jpg"
205 if [ "$xstuff" ]; then
206   echo "Installing backgrounds..."
207   for b in $backgrounds; do
208     for e in enlightenment e16; do
209       dir=$HOME$sub/.$e/backgrounds
210       t=$dir/$b
211       mkdir -p $dir
212       ln -s $here/bg/$b $t.new
213       mv $t.new $t
214     done
215     echo "  $b"
216   done
217   echo "        all done."
218 fi
219
220 ###--------------------------------------------------------------------------
221 ### Install useful scripts included in this package.
222
223 scripts="
224   mdw-editor
225   mdw-pager
226   mdw-conf
227   mdw-build
228   emacsclient-hack
229   movemail-hack
230   emerge-hack
231   lesspipe.sh
232   start-ssh-agent
233   svnwrap
234   hyperspec"
235 [ "$xstuff" ] && scripts="$scripts
236   xinitcmd
237   un-backslashify-selection
238   lock-screen
239   xshutdown"
240 echo "Installing scripts..."
241 mkdir -p $HOME$sub/bin
242 for s in $scripts; do
243   ft=$HOME$sub/bin/$s
244   ln -s $here/bin/$s $ft.new
245   mv $ft.new $ft
246   echo "  $s"
247 done
248 echo "  all done."
249
250 ###--------------------------------------------------------------------------
251 ### Set up the Emacs config.
252
253 $echon "Finding a suitable emacs:$echoc"
254 emacs=no
255 for i in emacs22 emacs23 emacs21 emacs; do
256   if type -p >/dev/null $i; then
257     emacs=$i
258     break
259   fi
260 done
261 if [ $emacs = no ]; then
262   echo " failed."
263   emacs=:
264 else
265   echo " $emacs."
266 fi
267
268 echo "Installing Emacs packages..."
269 emacspkg="
270   make-regexp
271   ew-hols
272   mdw-gnus-patch
273   git git-blame vc-git stgit
274   quilt"
275 for elib in $emacspkg; do
276   $echon "  $elib:$echoc"
277   if $false $emacs >/dev/null 2>&1 --no-site-file --batch --eval '
278        (progn
279          (setq load-path (nconc load-path (list "~/lib/emacs")))
280          (kill-emacs (condition-case nil
281                          (progn (load-library "'"$elib"'") 0)
282                        (error 1))))'; then
283     echo " already installed."
284   else
285     if [ -f el/$elib.el ]; then
286       cp el/$elib.el $HOME$sub/lib/emacs/$elib.el
287     else
288       $echon " downloading$echoc"
289       $GETURL $HOME$sub/lib/emacs/$elib.el $REPO/$elib.el
290     fi
291     $echon " compiling$echoc"
292     (cd $HOME$sub/lib/emacs;
293       $emacs >/dev/null 2>&1 --no-site-file --batch \
294         --eval '(byte-compile-file "'"$elib.el"'")')
295     echo " done."
296   fi
297 done
298 echo "  all done."
299
300 $echon "Setting up Emacs configuration:$echoc"
301 $echon " linking$echoc"
302 for f in dot-emacs.el Makefile; do
303   set -- $(echo $link | tr : ' ')
304   ln -s $here/el/$f $HOME$sub/lib/emacs/$f.new
305   mv $HOME$sub/lib/emacs/$f.new $HOME$sub/lib/emacs/$f
306 done
307 $echon " compiling$echoc"
308 make >/dev/null 2>&1 -C $HOME$sub/lib/emacs EMACS=$emacs
309 echo " done."
310
311 ###----- That's all, folks --------------------------------------------------